﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Freeport
{
    public partial class Frm_Principal : Form
    {
        public static Frm_Principal frm_principal = null;//Crear variable de tipo Frm_Principal

        string mensaje = "";

        public Frm_Principal()
        {
            InitializeComponent();
            Puerto.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(Recepcion);//Linea imprescindible para transmitir
        }
        
        private void Frm_Principal_Load(object sender, EventArgs e)
        {
            Txt_Envio.Focus();
            //Para traballar cos caracteres no noso idioma
            this.Puerto.Encoding = Encoding.GetEncoding(28591);
        }

        
        private void Recepcion(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            //Recibir Datos
            mensaje = Puerto.ReadLine();
            this.Invoke(new EventHandler(Actualizar));
        }

        private void Actualizar(object s, EventArgs e)
        {
            Txt_Chat.Text = Txt_Chat.Text + "El: " + mensaje + "\r\n";
        }
        
       
        private void Btn_Config_Click(object sender, EventArgs e)
        {
            frm_principal = this;//frm_principal = O formulario actual
            Frm_Secundario frm_secundario = new Frm_Secundario();//Creamos en memoria o segundo formulario
            frm_secundario.ShowDialog();//Amosa o segundo formulario poñendo o primeiro a enabled false (no usable)
        }

        private void Btn_Salir_Click(object sender, EventArgs e)
        {
            DialogResult aviso = MessageBox.Show("Quere pechar o programa?", "Atención", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning);//Aviso de advertencia al salir
            if(aviso == DialogResult.OK)
            {
                Puerto.Close();
                this.Close();
            }       
        }

        private void Btn_Borrar_Click(object sender, EventArgs e)
        {
            DialogResult aviso = MessageBox.Show("Quere borrar o chat?", "Atención", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation);//Aviso de advertencia al borrar
            if (aviso == DialogResult.OK)
            {
                Txt_Chat.Text = "";

            }
        }

        private void Btn_Enviar_Click(object sender, EventArgs e)
        {
            if(Txt_Envio.Text != "" && Puerto.IsOpen)
            {

                Puerto.WriteLine(Txt_Envio.Text);
                Txt_Chat.Text = Txt_Chat.Text + "Eu: " + Txt_Envio.Text + "\r\n";
                Txt_Envio.Text = "";//Borrar o cadro de texto ao enviar a mensaxe
                
            }
            else
            {
                MessageBox.Show("Non se pode enviar unha mensaxe baleira ou co porto pechado","",MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            
        }

        private void Txt_Envio_KeyDown(object sender, KeyEventArgs e)
        {
            if(e.KeyCode == Keys.Enter)
            {
                if (Txt_Envio.Text != "" && Puerto.IsOpen)
                {

                    Puerto.WriteLine(Txt_Envio.Text);
                    Txt_Chat.Text = Txt_Chat.Text + "Eu: " + Txt_Envio.Text + "\r\n";
                    Txt_Envio.Text = "";//Borrar o cadro de texto ao enviar a mensaxe

                }
                else
                {
                    MessageBox.Show("Non se pode enviar unha mensaxe baleira ou co porto pechado", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
    }
}
