﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO.Ports;
using System.IO;
using System.Xml;
using System.Xml.Linq;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Freeport
{
    public partial class Frm_Secundario : Form
    {
        public Frm_Secundario()
        {
            InitializeComponent();
        }

        private void Btn_Conectar_Click(object sender, EventArgs e)
        {
            

            Frm_Principal.frm_principal.Puerto.Close();
            Frm_Principal.frm_principal.Puerto.PortName = Cmb_Puerto.Text;
            Frm_Principal.frm_principal.Puerto.BaudRate = Convert.ToInt16(Cmb_Baudrate.Text);
            Frm_Principal.frm_principal.Puerto.DataBits = Convert.ToInt16(Cmb_Databits.Text);
            Frm_Principal.frm_principal.Puerto.Parity = (System.IO.Ports.Parity)Cmb_Paridad.SelectedItem;
            Frm_Principal.frm_principal.Puerto.StopBits = (System.IO.Ports.StopBits)Cmb_Stopbits.SelectedItem;
            Frm_Principal.frm_principal.Puerto.Open();

            XmlDocument doc = new XmlDocument();
            XmlElement raiz = doc.CreateElement("Configuracion");
            doc.AppendChild(raiz);
            XmlElement puerto = doc.CreateElement("Puerto");
            puerto.AppendChild(doc.CreateTextNode(Convert.ToString(Cmb_Puerto.SelectedIndex)));
            raiz.AppendChild(puerto);
            XmlElement baudrate = doc.CreateElement("Baudrate");
            baudrate.AppendChild(doc.CreateTextNode(Convert.ToString(Cmb_Baudrate.SelectedIndex)));
            raiz.AppendChild(baudrate);
            XmlElement databits = doc.CreateElement("Databits");
            databits.AppendChild(doc.CreateTextNode(Convert.ToString(Cmb_Databits.SelectedIndex)));
            raiz.AppendChild(databits);
            XmlElement paridad = doc.CreateElement("Paridad");
            paridad.AppendChild(doc.CreateTextNode(Convert.ToString(Cmb_Paridad.SelectedIndex)));
            raiz.AppendChild(paridad);
            XmlElement stopbits = doc.CreateElement("Stopbits");
            stopbits.AppendChild(doc.CreateTextNode(Convert.ToString(Cmb_Stopbits.SelectedIndex)));
            raiz.AppendChild(stopbits);
            doc.Save(Application.StartupPath + "\\config.xml");

            this.Close();
        }

        private void Frm_Secundario_Load(object sender, EventArgs e)
        {
            //Declaramos unha variable matriz de cadeas para conter os nomes dos portos que se atopen no ordenador
            string[] portos = SerialPort.GetPortNames();
            //Colocamos no combo a matriz de portos atopada
            foreach (string port in portos)
            {
                Cmb_Puerto.Items.Add(port);
            }
            Cmb_Puerto.SelectedIndex = 0;

            Cmb_Paridad.DataSource = Enum.GetValues(typeof(System.IO.Ports.Parity));
            Cmb_Stopbits.DataSource = Enum.GetValues(typeof(System.IO.Ports.StopBits));

            
            if(File.Exists(Application.StartupPath + "\\config.xml"))//Control de error por se non existe config.xml
            {
                XDocument xdoc = XDocument.Load(Application.StartupPath + "\\config.xml");
                var elementos = from dato in xdoc.Descendants() select dato;
                foreach (var dato in xdoc.Descendants("Configuracion"))
                {
                    Cmb_Puerto.SelectedIndex = Convert.ToByte(dato.Element("Puerto").Value);
                    Cmb_Baudrate.SelectedIndex = Convert.ToByte(dato.Element("Baudrate").Value);
                    Cmb_Databits.SelectedIndex = Convert.ToByte(dato.Element("Databits").Value);
                    Cmb_Paridad.SelectedIndex = Convert.ToByte(dato.Element("Paridad").Value);
                    Cmb_Stopbits.SelectedIndex = Convert.ToByte(dato.Element("Stopbits").Value);
                }
            }             
        }
    }
}
